searchNodes=[{"doc":"Crawly is a fast high-level web crawling &amp; scraping framework for Elixir.","ref":"Crawly.html","title":"Crawly","type":"module"},{"doc":"Fetches a given url. This function is mainly used for the spiders development when you need to get individual pages and parse them.The fetched URL is being converted to a request, and the request is piped through the middlewares specified in a config (with the exception of Crawly.Middlewares.DomainFilter, Crawly.Middlewares.RobotsTxt)Provide a spider with the :with option to fetch a given webpage using that spider.Fetching with a spiderTo fetch a response from a url with a spider, define your spider, and pass the module name to the :with option. iex&gt; Crawly.fetch(&quot;https://www.example.com&quot;, with: MySpider) {%HTTPoison.Response{...}, %{...}, [...], %{...}}Using the :with option will return a 4 item tuple:The HTTPoison responseThe result returned from the parse_item/1 callbackThe list of items that have been processed by the declared item pipelines.The pipeline state, included for debugging purposes.","ref":"Crawly.html#fetch/2","title":"Crawly.fetch/2","type":"function"},{"doc":"Returns a list of known modules which implements Crawly.Spider behaviour.Should not be used for spider management. Use functions defined in Crawly.Engine for that.","ref":"Crawly.html#list_spiders/0","title":"Crawly.list_spiders/0","type":"function"},{"doc":"Parses a given response with a given spider. Allows to quickly see the outcome of the given :parse_item implementation.","ref":"Crawly.html#parse/2","title":"Crawly.parse/2","type":"function"},{"doc":"","ref":"Crawly.html#t:headers_opt/0","title":"Crawly.headers_opt/0","type":"type"},{"doc":"","ref":"Crawly.html#t:parsed_item_result/0","title":"Crawly.parsed_item_result/0","type":"type"},{"doc":"","ref":"Crawly.html#t:parsed_items/0","title":"Crawly.parsed_items/0","type":"type"},{"doc":"","ref":"Crawly.html#t:pipeline_state/0","title":"Crawly.pipeline_state/0","type":"type"},{"doc":"","ref":"Crawly.html#t:request_opt/0","title":"Crawly.request_opt/0","type":"type"},{"doc":"","ref":"Crawly.html#t:with_opt/0","title":"Crawly.with_opt/0","type":"type"},{"doc":"Crawly HTTP API. Allows to schedule/stop/get_stats of all running spiders.","ref":"Crawly.API.Router.html","title":"Crawly.API.Router","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"Crawly.API.Router.html#call/2","title":"Crawly.API.Router.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"Crawly.API.Router.html#init/1","title":"Crawly.API.Router.init/1","type":"function"},{"doc":"A behavior module for defining Crawly FetchersA fetcher is expected to implement a fetch callback which should take Crawly.Request, HTTP client options and return Crawly.Response.","ref":"Crawly.Fetchers.Fetcher.html","title":"Crawly.Fetchers.Fetcher","type":"behaviour"},{"doc":"","ref":"Crawly.Fetchers.Fetcher.html#c:fetch/2","title":"Crawly.Fetchers.Fetcher.fetch/2","type":"callback"},{"doc":"","ref":"Crawly.Fetchers.Fetcher.html#t:t/0","title":"Crawly.Fetchers.Fetcher.t/0","type":"type"},{"doc":"Implements Crawly.Fetchers.Fetcher behavior based on HTTPoison HTTP client","ref":"Crawly.Fetchers.HTTPoisonFetcher.html","title":"Crawly.Fetchers.HTTPoisonFetcher","type":"module"},{"doc":"Callback implementation for Crawly.Fetchers.Fetcher.fetch/2.","ref":"Crawly.Fetchers.HTTPoisonFetcher.html#fetch/2","title":"Crawly.Fetchers.HTTPoisonFetcher.fetch/2","type":"function"},{"doc":"Implements Crawly.Fetchers.Fetcher behavior for Splash Javascript rendering.Splash is a lightweight QT based Javascript rendering engine. See: https://splash.readthedocs.io/Splash exposes the render.html endpoint which renders incoming requests sent with ?url get parameter.This particular Splash fetcher converts all requests made by Crawly to Splash requests, and cleans up the final responses, by removing the Splash parts from the response.It's possible to start splash server in any documented way. One of the options is to run it locally with a help of docker: docker run -it -p 8050:8050 scrapinghub/splashIn this case you have to confugure the fetcher in the following way: fetcher: {Crawly.Fetchers.Splash, [base_url: &quot;http://localhost:8050/render.html&quot;]},","ref":"Crawly.Fetchers.Splash.html","title":"Crawly.Fetchers.Splash","type":"module"},{"doc":"Callback implementation for Crawly.Fetchers.Fetcher.fetch/2.","ref":"Crawly.Fetchers.Splash.html#fetch/2","title":"Crawly.Fetchers.Splash.fetch/2","type":"function"},{"doc":"","ref":"Crawly.Loggers.SendToUiBackend.html","title":"Crawly.Loggers.SendToUiBackend","type":"module"},{"doc":"","ref":"Crawly.Loggers.SendToUiBackend.html#handle_call/2","title":"Crawly.Loggers.SendToUiBackend.handle_call/2","type":"function"},{"doc":"","ref":"Crawly.Loggers.SendToUiBackend.html#handle_event/2","title":"Crawly.Loggers.SendToUiBackend.handle_event/2","type":"function"},{"doc":"","ref":"Crawly.Loggers.SendToUiBackend.html#init/1","title":"Crawly.Loggers.SendToUiBackend.init/1","type":"function"},{"doc":"Define Crawly setting types","ref":"Crawly.Settings.html","title":"Crawly.Settings","type":"module"},{"doc":"","ref":"Crawly.Settings.html#t:middleware/0","title":"Crawly.Settings.middleware/0","type":"type"},{"doc":"","ref":"Crawly.Settings.html#t:numeric_setting/0","title":"Crawly.Settings.numeric_setting/0","type":"type"},{"doc":"","ref":"Crawly.Settings.html#t:pipeline/0","title":"Crawly.Settings.pipeline/0","type":"type"},{"doc":"","ref":"Crawly.Settings.html#t:retry/0","title":"Crawly.Settings.retry/0","type":"type"},{"doc":"","ref":"Crawly.Settings.html#t:t/0","title":"Crawly.Settings.t/0","type":"type"},{"doc":"Utility functions for Crawly","ref":"Crawly.Utils.html","title":"Crawly.Utils","type":"module"},{"doc":"A helper function which joins relative url with a base URL","ref":"Crawly.Utils.html#build_absolute_url/2","title":"Crawly.Utils.build_absolute_url/2","type":"function"},{"doc":"A helper function which joins relative url with a base URL for a list","ref":"Crawly.Utils.html#build_absolute_urls/2","title":"Crawly.Utils.build_absolute_urls/2","type":"function"},{"doc":"","ref":"Crawly.Utils.html#get_modules_from_applications/0","title":"Crawly.Utils.get_modules_from_applications/0","type":"function"},{"doc":"A helper which allows to extract a given setting.Returned value is a result of intersection of the global settings and settings defined as settings_override inside the spider. Settings defined on spider are taking precedence over the global settings defined in the config.","ref":"Crawly.Utils.html#get_settings/3","title":"Crawly.Utils.get_settings/3","type":"function"},{"doc":"Returns a list of known modules which implements Crawly.Spider behaviour","ref":"Crawly.Utils.html#list_spiders/0","title":"Crawly.Utils.list_spiders/0","type":"function"},{"doc":"Pipeline/Middleware helperExecutes a given list of pipelines on the given item, mimics filtermap behavior. Takes an item and state and passes it through a list of modules which implements a pipeline behavior, executing the pipeline's Crawly.Pipeline.run/3 function.The pipe function must either return a boolean (false), or an updated item.If false is returned by a pipeline, the item is dropped. It will not be processed by any descendant pipelines.In case of a pipeline crash, the pipeline will be skipped and the item will be passed on to descendant pipelines.The state variable is used to persist the information accross multiple items.Usage in TestsThe Crawly.Utils.pipe/3 helper can be used in pipeline testing to simulate a set of middlewares/pipelines.Internally, this function is used for both middlewares and pipelines. Hence, you can use it for testing modules that implement the Crawly.Pipeline behaviour.For example, one can test that a given item is manipulated by a pipeline as so:item = %{my: &quot;item&quot;} state = %{} pipelines = [ MyCustomPipelineOrMiddleware ] {new_item, new_state} = Crawly.Utils.pipe(pipelines, item, state)","ref":"Crawly.Utils.html#pipe/3","title":"Crawly.Utils.pipe/3","type":"function"},{"doc":"A helper function which returns a Request structure for the given URL","ref":"Crawly.Utils.html#request_from_url/1","title":"Crawly.Utils.request_from_url/1","type":"function"},{"doc":"A helper function which converts a list of URLS into a requests list.","ref":"Crawly.Utils.html#requests_from_urls/1","title":"Crawly.Utils.requests_from_urls/1","type":"function"},{"doc":"A wrapper over Process.send after This wrapper should be used instead of Process.send_after, so it's possible to mock the last one. To avoid race conditions on worker's testing.","ref":"Crawly.Utils.html#send_after/3","title":"Crawly.Utils.send_after/3","type":"function"},{"doc":"Defines the structure of spider's result.Usage with ParsersA %ParsedItem{} is piped through each parser pipeline module when it is declared. Refer to Crawly.Pipeline for further documentation.","ref":"Crawly.ParsedItem.html","title":"Crawly.ParsedItem","type":"module"},{"doc":"","ref":"Crawly.ParsedItem.html#t:item/0","title":"Crawly.ParsedItem.item/0","type":"type"},{"doc":"","ref":"Crawly.ParsedItem.html#t:t/0","title":"Crawly.ParsedItem.t/0","type":"type"},{"doc":"Request wrapperDefines Crawly request structure.","ref":"Crawly.Request.html","title":"Crawly.Request","type":"module"},{"doc":"Create new Crawly.Request from url, headers and options","ref":"Crawly.Request.html#new/3","title":"Crawly.Request.new/3","type":"function"},{"doc":"Same as Crawly.Request.new/3 from but allows to specify middlewares as the 4th parameter.","ref":"Crawly.Request.html#new/4","title":"Crawly.Request.new/4","type":"function"},{"doc":"","ref":"Crawly.Request.html#t:header/0","title":"Crawly.Request.header/0","type":"type"},{"doc":"","ref":"Crawly.Request.html#t:option/0","title":"Crawly.Request.option/0","type":"type"},{"doc":"","ref":"Crawly.Request.html#t:t/0","title":"Crawly.Request.t/0","type":"type"},{"doc":"","ref":"Crawly.Request.html#t:url/0","title":"Crawly.Request.url/0","type":"type"},{"doc":"Define Crawly response structure","ref":"Crawly.Response.html","title":"Crawly.Response","type":"module"},{"doc":"","ref":"Crawly.Response.html#t:t/0","title":"Crawly.Response.t/0","type":"type"},{"doc":"A behavior module for implementing a Crawly SpiderA Spider is a module which is responsible for defining:init/0 function, which must return a keyword list with start_urls/start_requests listinit/1 same as init, but also takes a list of options sent from Enginebase_url/0 function responsible for filtering out requests not related to a given websiteoverride_settings/0 function that is called each time a setting is referenced internally. Allows overriding of Crawly configuration at the spider-level.parse_item/1 function which is responsible for parsing the downloaded request and converting it into items which can be stored and new requests which can be scheduledcustom_settings/0 an optional callback which can be used in order to provide custom spider specific settings. Should define a list with custom settings and their values. These values will take precedence over the global settings defined in the config.","ref":"Crawly.Spider.html","title":"Crawly.Spider","type":"behaviour"},{"doc":"","ref":"Crawly.Spider.html#c:base_url/0","title":"Crawly.Spider.base_url/0","type":"callback"},{"doc":"","ref":"Crawly.Spider.html#c:init/0","title":"Crawly.Spider.init/0","type":"callback"},{"doc":"","ref":"Crawly.Spider.html#c:init/1","title":"Crawly.Spider.init/1","type":"callback"},{"doc":"","ref":"Crawly.Spider.html#c:override_settings/0","title":"Crawly.Spider.override_settings/0","type":"callback"},{"doc":"","ref":"Crawly.Spider.html#c:parse_item/1","title":"Crawly.Spider.parse_item/1","type":"callback"},{"doc":"A behavior module for implementing a pipeline module. Pipelines allow for customization of how Crawly.Requests, Crawly.Responses, and :items set on Crawly.ParsedItem are processed. Each pipeline is called in sequence, with the result of each being passed to the next pipeline.A pipeline is a module which takes a given item, and executes a run callback on a given item.A state argument is used to share common information accros multiple items. May have preset keys that are set internally by Crawly. Custom pipeline modules may set information to be further used down the declared list of pipeline modules.An opts argument is used to pass configuration to the pipeline through tuple-based declarations.Example Config Declaration# config.exs :crawly, parsers: [ # with options {Crawly.ExtractRequests, selector: &quot;a&quot; } ], middlewares: [ Crawly.Middlewares.DomainFilter, Crawly.Middlewares.UniqueRequest, Crawly.Middlewares.RobotsTxt ], pipelines: [Crawly.Pipelines.JSONEncoder ]Request MiddlewaresRequest middlewares are called for each request returned on the :requests key of a ParsedItem.Response ParsersThe following are set on the state for parsers::response: A Crawly.Response struct. The response from the used Fetcher.:spider_name: The name of the spider that is is currently being used. Can be used for processing customizations, logging, or referencing settings.Must return a Map on the first tuple position, which follows the same typespecs as a ParsedItem. Only recognized keys will be used.Item PipelinesItem pipelines are called for each enumerable result on the:items key of a ParsedItem.","ref":"Crawly.Pipeline.html","title":"Crawly.Pipeline","type":"behaviour"},{"doc":"","ref":"Crawly.Pipeline.html#c:run/2","title":"Crawly.Pipeline.run/2","type":"callback"},{"doc":"","ref":"Crawly.Pipeline.html#c:run/3","title":"Crawly.Pipeline.run/3","type":"callback"},{"doc":"Set/update cookies for requests. The cookies are being automatically picked up from prev_responses stored by Crawly. Only name/value pairs are taken into account, all other options like domain, secure and others are ignored.Example Declarationmiddlewares: [ Crawly.Middlewares.AutoCookiesManager ]","ref":"Crawly.Middlewares.AutoCookiesManager.html","title":"Crawly.Middlewares.AutoCookiesManager","type":"module"},{"doc":"","ref":"Crawly.Middlewares.AutoCookiesManager.html#run/2","title":"Crawly.Middlewares.AutoCookiesManager.run/2","type":"function"},{"doc":"Filters out requests which are going outside of the crawled domain.The domain that is used to compare against the request url is obtained from the spider's c:Crawly.Spider.base_url callback.Does not accept any options. Tuple-based configuration optionswill be ignored.Example Declarationmiddlewares: [ Crawly.Middlewares.DomainFilter ]","ref":"Crawly.Middlewares.DomainFilter.html","title":"Crawly.Middlewares.DomainFilter","type":"module"},{"doc":"Callback implementation for Crawly.Pipeline.run/3.","ref":"Crawly.Middlewares.DomainFilter.html#run/3","title":"Crawly.Middlewares.DomainFilter.run/3","type":"function"},{"doc":"Request settings middlewareAllows to specify HTTP request settings like follow_redirect, or request timeout.If using HTTPoisonFetcher (the default), please refer to the HTTPoison Request documentation for full list of :options. Example UsageExample Declarationmiddlewares: [ {Crawly.Middlewares.RequestOptions, [timeout: 30_000, recv_timeout: 15000]} ]Declaring proxy settingsmiddlewares: [ {Crawly.Middlewares.RequestOptions, [proxy: {&quot;https://my_host.com&quot;, 3000}, proxy_auth: {&quot;my_user&quot;, &quot;my_password}]} ]","ref":"Crawly.Middlewares.RequestOptions.html","title":"Crawly.Middlewares.RequestOptions","type":"module"},{"doc":"Callback implementation for Crawly.Pipeline.run/3.","ref":"Crawly.Middlewares.RequestOptions.html#run/3","title":"Crawly.Middlewares.RequestOptions.run/3","type":"function"},{"doc":"Obey robots.txtA robots.txt file tells search engine crawlers which pages or files the crawler can or can't request from your site. This is used mainly to avoid overloading a site with requests!No options are required for this middleware. Any tuple-based configurations options passed will be ignored.Example Declarationmiddlewares: [ Crawly.Middlewares.RobotsTxt ]","ref":"Crawly.Middlewares.RobotsTxt.html","title":"Crawly.Middlewares.RobotsTxt","type":"module"},{"doc":"Callback implementation for Crawly.Pipeline.run/3.","ref":"Crawly.Middlewares.RobotsTxt.html#run/3","title":"Crawly.Middlewares.RobotsTxt.run/3","type":"function"},{"doc":"Avoid scheduling requests for the same pages.","ref":"Crawly.Middlewares.UniqueRequest.html","title":"Crawly.Middlewares.UniqueRequest","type":"module"},{"doc":"","ref":"Crawly.Middlewares.UniqueRequest.html#run/2","title":"Crawly.Middlewares.UniqueRequest.run/2","type":"function"},{"doc":"Set/Rotate user agents for crawling. The user agents are read from :crawly, :user_agents sessions.The default value for the user agent is: Crawly Bot 1.0Rotation is determined through Enum.random/1.Options:user_agents, optional. A list of user agent strings to rotate. Defaults to &quot;Crawly Bot 1.0&quot;.Example Declarationmiddlewares: [ {UserAgent, user_agents: [&quot;My Custom Bot&quot;] } ]","ref":"Crawly.Middlewares.UserAgent.html","title":"Crawly.Middlewares.UserAgent","type":"module"},{"doc":"","ref":"Crawly.Middlewares.UserAgent.html#run/3","title":"Crawly.Middlewares.UserAgent.run/3","type":"function"},{"doc":"Encodes a given item (map) into CSV. Does not flatten nested maps.OptionsIf no fields are given, the item is dropped from the pipeline.:fields, required: The fields to extract out from the scraped item. Falls back to the global config :item.Example Usage iex&gt; item = %{my: &quot;first&quot;, other: &quot;second&quot;, ignore: &quot;this_field&quot;} iex&gt; Crawly.Pipelines.CSVEncoder.run(item, %{}, fields: [:my, :other]) {&quot;first,second&quot;, %{}}","ref":"Crawly.Pipelines.CSVEncoder.html","title":"Crawly.Pipelines.CSVEncoder","type":"module"},{"doc":"Filters out duplicated items based on the provided item_id.Stores identifier values in state under the :duplicates_filter key.OptionsIf item unique identifier is not provided, this pipeline does nothing.:item_id, required: Designates a field to be used to check for duplicates. Falls back to global config :item_id.Example Usage iex&gt; item = %{my: &quot;item&quot;} iex&gt; {_unchanged, new_state} = DuplicatesFilter.run(first, %{}, item_id: :my) # Rerunning the item through the pipeline will drop the item iex&gt; DuplicatesFilter.run(first, %{}, item_id: :id) {false, %{ duplicates_filter: %{&quot;item&quot; =&gt; true} }}","ref":"Crawly.Pipelines.DuplicatesFilter.html","title":"Crawly.Pipelines.DuplicatesFilter","type":"module"},{"doc":"","ref":"Crawly.Pipelines.Experimental.SendToUI.html","title":"Crawly.Pipelines.Experimental.SendToUI","type":"module"},{"doc":"Encodes a given item (map) into JSONNo options are available for this pipeline.Example Declarationpipelines: [ Crawly.Pipelines.JSONEncoder ]Example Usage iex&gt; JSONEncoder.run(%{my: &quot;field&quot;}, %{}) {&quot;{&quot;my&quot;:&quot;field&quot;}&quot;, %{}}","ref":"Crawly.Pipelines.JSONEncoder.html","title":"Crawly.Pipelines.JSONEncoder","type":"module"},{"doc":"Ensure that scraped item contains a set of required fields.OptionsIf the fields to check are not provided, the pipeline does nothing.:fields, required: The list of required fields. Fallsback to global config :item.Example Declarationpipelines: [ {Crawly.Pipelines.Validate, fields: [:id, :url, :date]} ]Example Usage# Drops the scraped item that does not have the required fields iex&gt; Validate.run(%{my: &quot;field&quot;}, %{}, fields: [:id]) {false, %{}}","ref":"Crawly.Pipelines.Validate.html","title":"Crawly.Pipelines.Validate","type":"module"},{"doc":"Stores a given item into FilesystemPipeline Lifecycle:When run (by Crawly.Utils.pipe), creates a file descriptor if not already created.Performs the write operationFile descriptor is reused by passing it through the pipeline state with :write_to_file_fdNote: File.close is not necessary due to the file descriptor being automatically closed upon the end of a the parent process.Refer to https://github.com/oltarasenko/crawly/pull/19#discussion_r350599526 for relevant discussion.OptionsIn the absence of tuple-based options being passed, the pipeline will fallback onto the config of :crawly, Crawly.Pipelines.WriteToFile, for the :folder and :extension keys:folder, optional. The folder in which the file will be created. Defaults to current project's folder. If provided folder does not exist it's created.:extension, optional. The file extension in which the file will be created with. Defaults to jl.:include_timestamp, boolean, optional, true by default. Allows to add timestamp to the filename.Example Declarationpipelines: [ Crawly.Pipelines.JSONEncoder, {Crawly.Pipelines.WriteToFile, folder: &quot;/tmp&quot;, extension: &quot;csv&quot;} ]Example Outputiex&gt; item = %{my: &quot;item&quot;} iex&gt; WriteToFile.run(item, %{}, folder: &quot;/tmp&quot;, extension: &quot;csv&quot;) { %{my: &quot;item&quot;} , %{write_to_file_fd: #PID&lt;0.123.0&gt;} }","ref":"Crawly.Pipelines.WriteToFile.html","title":"Crawly.Pipelines.WriteToFile","type":"module"},{"doc":"Data Storage, is a module responsible for storing crawled items. On the high level it's possible to represent the architecture of items storage this way: ┌──────────────────┐ │ │ ┌------------------┐ │ DataStorage &lt;─────────────┤ From crawlers1,2 │ │ │ └------------------┘ └─────────┬────────┘ │ │ │ │ ┌────────────▼─────────────────┐ │ │ │ │ │ │┌───────────▼──────────┐ ┌───────────▼──────────┐ │ DataStorageWorker1 │ │ DataStorageWorker2 │ │ (Crawler1) │ │ (Crawler2) │ └──────────────────────┘ └──────────────────────┘","ref":"Crawly.DataStorage.html","title":"Crawly.DataStorage","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Crawly.DataStorage.html#child_spec/1","title":"Crawly.DataStorage.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Crawly.DataStorage.html#init/1","title":"Crawly.DataStorage.init/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.html#start_link/1","title":"Crawly.DataStorage.start_link/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.html#start_worker/2","title":"Crawly.DataStorage.start_worker/2","type":"function"},{"doc":"","ref":"Crawly.DataStorage.html#stats/1","title":"Crawly.DataStorage.stats/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.html#store/2","title":"Crawly.DataStorage.store/2","type":"function"},{"doc":"A worker process which stores items for individual spiders. All items are pre-processed by item_pipelines.All pipelines are using the state of this process for their internal needs (persistancy).The DataStorage.Worker will not write anything to a filesystem. Instead it would expect that pipelines are going to do that work.","ref":"Crawly.DataStorage.Worker.html","title":"Crawly.DataStorage.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Crawly.DataStorage.Worker.html#child_spec/1","title":"Crawly.DataStorage.Worker.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Crawly.DataStorage.Worker.html#init/1","title":"Crawly.DataStorage.Worker.init/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.Worker.html#start_link/1","title":"Crawly.DataStorage.Worker.start_link/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.Worker.html#stats/1","title":"Crawly.DataStorage.Worker.stats/1","type":"function"},{"doc":"","ref":"Crawly.DataStorage.Worker.html#store/2","title":"Crawly.DataStorage.Worker.store/2","type":"function"},{"doc":"Crawly Engine - process responsible for starting and stopping spiders.Stores all currently running spiders.","ref":"Crawly.Engine.html","title":"Crawly.Engine","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Crawly.Engine.html#child_spec/1","title":"Crawly.Engine.child_spec/1","type":"function"},{"doc":"","ref":"Crawly.Engine.html#get_crawl_id/1","title":"Crawly.Engine.get_crawl_id/1","type":"function"},{"doc":"","ref":"Crawly.Engine.html#get_manager/1","title":"Crawly.Engine.get_manager/1","type":"function"},{"doc":"","ref":"Crawly.Engine.html#get_spider_info/1","title":"Crawly.Engine.get_spider_info/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Crawly.Engine.html#init/1","title":"Crawly.Engine.init/1","type":"function"},{"doc":"","ref":"Crawly.Engine.html#list_known_spiders/0","title":"Crawly.Engine.list_known_spiders/0","type":"function"},{"doc":"","ref":"Crawly.Engine.html#refresh_spider_list/0","title":"Crawly.Engine.refresh_spider_list/0","type":"function"},{"doc":"","ref":"Crawly.Engine.html#running_spiders/0","title":"Crawly.Engine.running_spiders/0","type":"function"},{"doc":"","ref":"Crawly.Engine.html#start_link/0","title":"Crawly.Engine.start_link/0","type":"function"},{"doc":"Starts a spider. All options passed in the second argument will be passed along to the spider's init/1 callback.Reserved Options:crawl_id (binary). Optional, automatically generated if not set.:closespider_itemcount (integer | disabled). Optional, overrides the close spider item count on startup.:closespider_timeout (integer | disabled). Optional, overrides the close spider timeout on startup.:concurrent_requests_per_domain (integer). Optional, overrides the number of workers for a given spiderBackward compatibilityIf the 2nd positional argument is a binary, it will be set as the :crawl_id. Deprecated, will be removed in the future.","ref":"Crawly.Engine.html#start_spider/2","title":"Crawly.Engine.start_spider/2","type":"function"},{"doc":"","ref":"Crawly.Engine.html#stop_spider/2","title":"Crawly.Engine.stop_spider/2","type":"function"},{"doc":"","ref":"Crawly.Engine.html#t:crawl_id_opt/0","title":"Crawly.Engine.crawl_id_opt/0","type":"type"},{"doc":"","ref":"Crawly.Engine.html#t:spider_info/0","title":"Crawly.Engine.spider_info/0","type":"type"},{"doc":"","ref":"Crawly.Engine.html#t:started_spiders/0","title":"Crawly.Engine.started_spiders/0","type":"type"},{"doc":"","ref":"Crawly.Engine.html#t:t/0","title":"Crawly.Engine.t/0","type":"type"},{"doc":"Crawler manager moduleThis module is responsible for spawning all processes related to a given Crawler.The manager spawns the following processes tree. ┌────────────────┐ ┌───────────────────┐ │ Crawly.Manager ├────────&gt; Crawly.ManagerSup │ └────────────────┘ └─────────┬─────────┘ │ | │ | ┌──────────────────────────┤ │ │ │ │┌────────▼───────┐ ┌─────────▼───────┐ │ Worker1 │ │ Worker2 │ └────────┬───────┘ └────────┬────────┘ │ │ │ │ │ │ │ │┌────────▼─────────┐ ┌──────────▼───────────┐ │Crawly.DataStorage│ │Crawly.RequestsStorage│ └──────────────────┘ └──────────────────────┘","ref":"Crawly.Manager.html","title":"Crawly.Manager","type":"module"},{"doc":"","ref":"Crawly.Manager.html#add_workers/2","title":"Crawly.Manager.add_workers/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Crawly.Manager.html#child_spec/1","title":"Crawly.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Crawly.Manager.html#start_link/1","title":"Crawly.Manager.start_link/1","type":"function"},{"doc":"Request storage, a module responsible for storing urls for crawling ┌──────────────────┐ │ │ ┌------------------┐ │ RequestsStorage &lt;─────────────┤ From crawlers1,2 │ │ │ └------------------┘ └─────────┬────────┘ │ │ │ │ ┌────────────▼─────────────────┐ │ │ │ │ │ │┌───────────▼──────────┐ ┌───────────▼──────────┐ │RequestsStorageWorker1│ │RequestsStorageWorker2│ │ (Crawler1) │ │ (Crawler2) │ └──────────────────────┘ └──────────────────────┘All requests are going through one RequestsStorage process, which quickly finds the actual worker, which finally stores the request afterwords.","ref":"Crawly.RequestsStorage.html","title":"Crawly.RequestsStorage","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Crawly.RequestsStorage.html#child_spec/1","title":"Crawly.RequestsStorage.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Crawly.RequestsStorage.html#init/1","title":"Crawly.RequestsStorage.init/1","type":"function"},{"doc":"Pop a request out of requests storage","ref":"Crawly.RequestsStorage.html#pop/1","title":"Crawly.RequestsStorage.pop/1","type":"function"},{"doc":"","ref":"Crawly.RequestsStorage.html#start_link/1","title":"Crawly.RequestsStorage.start_link/1","type":"function"},{"doc":"Starts a worker for a given spider","ref":"Crawly.RequestsStorage.html#start_worker/2","title":"Crawly.RequestsStorage.start_worker/2","type":"function"},{"doc":"Get statistics from the requests storage","ref":"Crawly.RequestsStorage.html#stats/1","title":"Crawly.RequestsStorage.stats/1","type":"function"},{"doc":"Store request in related child worker","ref":"Crawly.RequestsStorage.html#store/2","title":"Crawly.RequestsStorage.store/2","type":"function"},{"doc":"Requests Storage, is a module responsible for storing requests for a given spider.Automatically filters out already seen requests (uses fingerprints approach to detect already visited pages).Pipes all requests through a list of middlewares, which do pre-processing of all requests before storing them","ref":"Crawly.RequestsStorage.Worker.html","title":"Crawly.RequestsStorage.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Crawly.RequestsStorage.Worker.html#child_spec/1","title":"Crawly.RequestsStorage.Worker.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Crawly.RequestsStorage.Worker.html#init/1","title":"Crawly.RequestsStorage.Worker.init/1","type":"function"},{"doc":"Pop a request out of requests storage","ref":"Crawly.RequestsStorage.Worker.html#pop/1","title":"Crawly.RequestsStorage.Worker.pop/1","type":"function"},{"doc":"","ref":"Crawly.RequestsStorage.Worker.html#start_link/2","title":"Crawly.RequestsStorage.Worker.start_link/2","type":"function"},{"doc":"Get statistics from the requests storage","ref":"Crawly.RequestsStorage.Worker.html#stats/1","title":"Crawly.RequestsStorage.Worker.stats/1","type":"function"},{"doc":"Store individual request request","ref":"Crawly.RequestsStorage.Worker.html#store/2","title":"Crawly.RequestsStorage.Worker.store/2","type":"function"},{"doc":"A worker process responsible for the actual work (fetching requests, processing responces)","ref":"Crawly.Worker.html","title":"Crawly.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Crawly.Worker.html#child_spec/1","title":"Crawly.Worker.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Crawly.Worker.html#init/1","title":"Crawly.Worker.init/1","type":"function"},{"doc":"","ref":"Crawly.Worker.html#start_link/1","title":"Crawly.Worker.start_link/1","type":"function"},{"doc":"TutorialIn this tutorial, we’ll assume that Elixir is already installed on your system. If that’s not the case, see Installation guide: https://elixir-lang.org/install.htmlWe are going to scrape https://www.homebase.co.uk, a website that contains products of different types.This tutorial will walk you through these tasks:Creating a new Crawly project.Writing a spider to crawl a site and extract data.Exporting the scraped data.Crawly is written in Elixir. If you’re new to the language you might want to start by getting an idea of what the language is like, to get the most out of Crawly.If you’re already familiar with other languages, and want to learn Elixir quickly, the Elixir website https://elixir-lang.org/learning.html is a good resource.","ref":"tutorial.html","title":"Tutorial","type":"extras"},{"doc":"Before you start crawling, you will have to set up a new Crawly project. Enter a directory where you’d like to store your code and run:mix new tutorial --supThis will create a tutorial directory with the following contents:tutorial ├── README.md ├── lib │   ├── tutorial │   │   └── application.ex │   └── tutorial.ex ├── mix.exs └── test ├── test_helper.exs └── tutorial_test.exs Switch to the project folder: cd ./tutorial and update the mix.exs file with the following code: defp deps do [ {:crawly, &quot;~&gt; 0.13.0&quot;}, {:floki, &quot;~&gt; 0.26.0&quot;} ] endNow run mix deps.get","ref":"tutorial.html#creating-a-project","title":"Tutorial - Creating a project","type":"extras"},{"doc":"Spiders are behaviours which you defined and that Crawly uses to extract information from a given website. The spider must implement the spider behaviour (it's required to implement parse_item/1, init/0, base_url/0 callbacks)This is the code for our first spider. Save it in a file named homebase.ex under the lib/tutorial/spiders directory of your project.defmodule Homebase do use Crawly.Spider @impl Crawly.Spider def base_url(), do: &quot;https://www.homebase.co.uk&quot; @impl Crawly.Spider def init() do [ start_urls: [ &quot;https://www.homebase.co.uk/our-range/tools&quot; ] ] end @impl Crawly.Spider def parse_item(_response) do %Crawly.ParsedItem{:items =&gt; [], :requests =&gt; []} end endAs you can see, our Spider implements the Crawly.Spider behaviour and defines some functions:base_url: method which returns base_urls for the given Spider, used in order to filter out all irrelevant requests. In our case we don't want our crawler to follow links going to social media sites and other partner sites (which are not related to the homebase website themselves)init(): must return a KW list which contains start_urls list which Crawler will begin to crawl from. Subsequent requests will be generated from these initial urls.parse_item(): function which will be called to handle response downloaded by Crawly. It must return the Crawly.ParsedItem structure.","ref":"tutorial.html#our-first-spider","title":"Tutorial - Our first spider","type":"extras"},{"doc":"To put our spider to work, go to the project’s top level directory and run:iex -S mix - It will start the Elixir application which we have created, and will open interactive console.Execute the following command in the opened Elixir console: Crawly.Engine.start_spider(Homebase)You will get an output similar to this:iex(2)&gt; Crawly.Engine.start_spider(Homebase) 14:07:50.188 [debug] Starting the manager for Elixir.Homebase 14:07:50.188 [debug] Starting requests storage worker for Elixir.Homebase... 14:07:50.987 [debug] Started 4 workers for Elixir.Homebase :ok 14:08:50.990 [info] Current crawl speed is: 0 items/min 14:08:50.990 [info] Stopping Homebase, itemcount timeout achieved","ref":"tutorial.html#how-to-run-our-spider","title":"Tutorial - How to run our spider","type":"extras"},{"doc":"Crawly schedules the Request objects returned by the init function of the Spider. Upon receiving a response for each one, it instantiates Response objects and calls the callback function associated with the request passing the response as argument.In our case we have not defined any data to be returned by the parse_item callback. And the Crawly worker processes (processes responsible for downloading requests) did not have any work to do. And in cases like that, they will slow down progressively, until the switch off (which happened because the Spider was not extracting items fast enough).And if you're wondering how to extract the data from the response, please hold on. We're going to cover it in the next section.","ref":"tutorial.html#what-just-happened-under-the-hood","title":"Tutorial - What just happened under the hood?","type":"extras"},{"doc":"The best way to learn how to extract data with Crawly is trying the selectors in Crawly shell.Start the Elixir shell using iex -S mix command.Now you can fetch a given HTTP response using the following command: response = Crawly.fetch(&quot;https://www.homebase.co.uk/our-range/tools&quot;)You will see something like:%HTTPoison.Response{ body: &quot;[response body here...]&quot; headers: [ {&quot;Date&quot;, &quot;Fri, 17 Apr 2020 10:34:35 GMT&quot;}, {&quot;Content-Type&quot;, &quot;text/html; charset=utf-8&quot;}, {&quot;Transfer-Encoding&quot;, &quot;chunked&quot;}, {&quot;Connection&quot;, &quot;keep-alive&quot;}, {&quot;Set-Cookie&quot;, &quot;__cfduid=d4c96698cfcfdfc9c1ef44ecb162b1cce1587119674; expires=Sun, 17-May-20 10:34:34 GMT; path=/; domain=.homebase.co.uk; HttpOnly; SameSite=Lax; Secure&quot;}, {&quot;Cache-Control&quot;, &quot;no-cache, no-store&quot;}, {&quot;Pragma&quot;, &quot;no-cache&quot;}, {&quot;Expires&quot;, &quot;-1&quot;}, {&quot;Vary&quot;, &quot;Accept-Encoding&quot;}, ..., {&quot;cf-request-id&quot;, &quot;02294d6d6f0000ffd430ad9200000001&quot;} ], request: %HTTPoison.Request{ body: &quot;&quot;, headers: [], method: :get, options: [], params: %{}, url: &quot;https://www.homebase.co.uk/our-range/tools&quot; }, request_url: &quot;https://www.homebase.co.uk/our-range/tools&quot;, status_code: 200 }Using the shell, you can try selecting elements using Floki with the response. Let's say that we want to extract all product categories links from the page above:{:ok, document} = Floki.parse_document(response.body) document |&gt; Floki.find(&quot;section.wrapper&quot;) |&gt; Floki.find(&quot;div.article-tiles.article-tiles--wide a&quot;) |&gt; Floki.attribute(&quot;href&quot;) [&quot;/our-range/tools/power-tools&quot;, &quot;/our-range/tools/garage-storage&quot;, &quot;/our-range/tools/hand-tools&quot;, &quot;/our-range/tools/tool-storage&quot;, &quot;/our-range/tools/ladders&quot;, &quot;/our-range/tools/safety-equipment-and-workwear&quot;, &quot;/our-range/tools/work-benches&quot;]The result of running the command above is a list of elements which contain href attribute of links selected with a.category-block-heading__title CSS selector. These URLs will be used in order to feed Crawly with requests to follow.In order to find the proper CSS selectors to use, you might find useful opening the target page from the shell in your web browser. You can use your browser developer tools to inspect the HTML and come up with a selector.Now let's navigate to one of the Homebase product pages and extract data from it.response = Crawly.fetch(&quot;https://www.homebase.co.uk/bosch-universalimpact-800-corded-hammer-drill_p494894&quot;) Extract the title with:{:ok, document} = Floki.parse_document(response.body) document |&gt; Floki.find(&quot;.page-title h1&quot;) |&gt; Floki.text() &quot;Bosch UniversalImpact 800 Corded Hammer Drill&quot;Extract the SKU with:document |&gt; Floki.find(&quot;.product-header-heading span&quot;) |&gt; Floki.text &quot;SKU: 494894&quot;Extract the price with:document |&gt; Floki.find(&quot;.price-value [itemprop=priceCurrency]&quot;) |&gt; Floki.text &quot;£82&quot;","ref":"tutorial.html#extracting-data","title":"Tutorial - Extracting data","type":"extras"},{"doc":"Let’s get back to our spider. Until now, it doesn’t extract any data, just makes an empty run. Let’s integrate the extraction logic above into our spider.defmodule Homebase do use Crawly.Spider @impl Crawly.Spider def base_url(), do: &quot;https://www.homebase.co.uk&quot; @impl Crawly.Spider def init() do [ start_urls: [ &quot;https://www.homebase.co.uk/our-range/tools&quot; ] ] end @impl Crawly.Spider def parse_item(response) do # Parse response body to document {:ok, document} = Floki.parse_document(response.body) # Extract product category URLs product_categories = document |&gt; Floki.find(&quot;section.wrapper&quot;) |&gt; Floki.find(&quot;div.article-tiles.article-tiles--wide a&quot;) |&gt; Floki.attribute(&quot;href&quot;) # Extract individual product page URLs product_pages = document |&gt; Floki.find(&quot;a.product-tile &quot;) |&gt; Floki.attribute(&quot;href&quot;) urls = product_pages ++ product_categories # Convert URLs into Requests requests = urls |&gt; Enum.uniq() |&gt; Enum.map(&amp;build_absolute_url/1) |&gt; Enum.map(&amp;Crawly.Utils.request_from_url/1) # Create item (for pages where items exists) item = %{ title: document |&gt; Floki.find(&quot;.page-title h1&quot;) |&gt; Floki.text(), sku: document |&gt; Floki.find(&quot;.product-header-heading span&quot;) |&gt; Floki.text(), price: document |&gt; Floki.find(&quot;.price-value [itemprop=priceCurrency]&quot;) |&gt; Floki.text() } %Crawly.ParsedItem{:items =&gt; [item], :requests =&gt; requests} end defp build_absolute_url(url), do: URI.merge(base_url(), url) |&gt; to_string() end You will also need to tell Crawly where to store the scraped data. Create config/config.exs file with the following contents:use Mix.Config config :crawly, pipelines: [ Crawly.Pipelines.JSONEncoder, {Crawly.Pipelines.WriteToFile, folder: &quot;/tmp&quot;, extension: &quot;jl&quot;} ]The scraped data will now be stored in a CSV file under /tmp directory on your filesystem. The name of the file will be the same as our spider name - in our case Homebase.jl.If you restart iex and run this spider Crawly.Engine.start_spider(Homebase), it will output messages like:17:23:42.435 [debug] Dropping request: https://www.homebase.co.uk/bon-safety-rain-de-pro-superlight-weight-rainsuit-xxl_p275608, as it&#39;s already processed 17:23:42.435 [debug] Dropping request: https://www.homebase.co.uk/bon-safety-rain-de-pro-superlight-weight-rainsuit-l_p275605, as it&#39;s already processed 17:23:42.435 [debug] Dropping request: https://www.homebase.co.uk/bon-safety-rain-de-pro-superlight-weight-rainsuit-xl_p275607, as it&#39;s already processedThat's because Crawly filters out requests which it has already visited during the current run.Go ahead and check the contents of your /tmp/Homebase.jl file. It should contain the scraped products like these:{&quot;title&quot;:&quot;26 Inch Tool Chest (4 Drawer)&quot;,&quot;sku&quot;:&quot;SKU: 555262&quot;,&quot;price&quot;:&quot;£175&quot;} {&quot;title&quot;:&quot;26 Inch Tool Chest (10 Drawer)&quot;,&quot;sku&quot;:&quot;SKU: 555260&quot;,&quot;price&quot;:&quot;£280&quot;} {&quot;title&quot;:&quot;Draper 26 Inch Tool Chest (8 Drawer)&quot;,&quot;sku&quot;:&quot;SKU: 518329&quot;,&quot;price&quot;:&quot;£435&quot;} {&quot;title&quot;:&quot;Draper 26 Inch Tool Chest (6 Drawer)&quot;,&quot;sku&quot;:&quot;SKU: 518327&quot;,&quot;price&quot;:&quot;£405&quot;} {&quot;title&quot;:&quot;Draper 26 Inch Tool Chest (4 Drawer)&quot;,&quot;sku&quot;:&quot;SKU: 518328&quot;,&quot;price&quot;:&quot;£350&quot;} {&quot;title&quot;:&quot;Draper 26 Inch Tool Storage Chest (9 Drawer)&quot;,&quot;sku&quot;:&quot;SKU: 518312&quot;,&quot;price&quot;:&quot;£150&quot;} {&quot;title&quot;:&quot;Draper 26 Inch Tool Chest (5 Drawer)&quot;,&quot;sku&quot;:&quot;SKU: 518311&quot;,&quot;price&quot;:&quot;£139&quot;} {&quot;title&quot;:&quot;3 Tier Tool Trolley&quot;,&quot;sku&quot;:&quot;SKU: 555311&quot;,&quot;price&quot;:&quot;£90&quot;} {&quot;title&quot;:&quot;Draper 26 Inch Intermediate Tool Chest (2 Drawer)&quot;,&quot;sku&quot;:&quot;SKU: 518309&quot;,&quot;price&quot;:&quot;£80&quot;} {&quot;title&quot;:&quot;2 Tier Tool Trolley&quot;,&quot;sku&quot;:&quot;SKU: 555310&quot;,&quot;price&quot;:&quot;£70&quot;}","ref":"tutorial.html#extracting-data-in-our-spider","title":"Tutorial - Extracting data in our spider","type":"extras"},{"doc":"This tutorial covered only the basics of Crawly, but there’s a lot of other features not mentioned here.You can continue from the section Basic concepts to know more about the basic Crawly features.","ref":"tutorial.html#next-steps","title":"Tutorial - Next steps","type":"extras"},{"doc":"Basic Concepts","ref":"basic_concepts.html","title":"Basic Concepts","type":"extras"},{"doc":"Data is fetched in a linear series of operations.New Requests is formed through Crawly.Spider.init/0.New Requests are pre-processed individually.Data is fetched, and a Response is returnedThe Spider receives the response and parses the response, returning new Requests and new parsed itemsParsed items are post-processed individually. New Requests from the Spider goes to step 2","ref":"basic_concepts.html#flow-from-request-response-parsed-item","title":"Basic Concepts - Flow from Request, Response, Parsed Item","type":"extras"},{"doc":"Spiders are modules which define how a certain site (or a group of sites) will be scraped, including how to perform the crawl (i.e. follow links) and how to extract structured data from their pages (i.e. scraping items). In other words, Spiders are the place where you define the custom behaviour for crawling and parsing pages for a particular site.For spiders, the scraping cycle goes through something like this:You start by generating the initial Requests to crawl the first URLs, and use a callback function called with the response downloaded from those requests.In the callback function, you parse the response (web page) and return a %Crawly.ParsedItem{} struct. This struct should contain new requests to follow and items to be stored.In the callback functions, you parse the page contents, typically using Floki (but you can also use any other library you prefer) and generate items with the parsed data.Spiders are executed in the context of Crawly.Worker processes, and you can control the amount of concurrent workers via concurrent_requests_per_domain setting.All requests are being processed sequentially and are pre-processed by Middlewares.All items are processed sequentially and are processed by Item pipelines.Behaviour functionsIn order to make a working web crawler, all the behaviour callbacks need to be implemented.init() - a part of the Crawly.Spider behaviour. This function should return a KVList which contains a start_urls entry with a list, which defines the starting requests made by Crawly. Alternatively you may provide start_requests if it's required to prepare first requests on init(). Which might be useful if, for example, you want to pass a session cookie to the starting request. Note: start_requests are processed before start_urls. ** This callback is going to be deprecated in favour of init/1. For now the backwords compatibility is kept with a help of macro which always generates init/1.init(options) same as init/0 but also takes options (which can be passed from the engine during the spider start).base_url() - defines a base_url of the given Spider. This function is used in order to filter out all requests which are going outside of the crawled website.parse_item(response) - a function which defines how a given response is translated into the Crawly.ParsedItem structure. On the high level this function defines the extraction rules for both Items and Requests.","ref":"basic_concepts.html#spiders","title":"Basic Concepts - Spiders","type":"extras"},{"doc":"Crawly uses Request and Response objects for crawling web sites.Typically, Request objects are generated in the spiders and pass across the system until they reach the Crawly.Worker process, which executes the request and returns a Response object which travels back to the spider that issued the request. The Request objects are being modified by the selected Middlewares, before hitting the worker.The request is defined as the following structure: @type t :: %Crawly.Request{ url: binary(), headers: [header()], prev_response: %{}, options: [option()] } @type header() :: {key(), value()}Where:url - is the url of the requestheaders - define http headers which are going to be used with the given requestoptions - would define options (like follow redirects).Crawly uses HTTPoison library to perform the requests, but we have plans to extend the support with other pluggable backends like selenium and others.Responses are defined in the same way as HTTPoison responses. See more details here: https://hexdocs.pm/httpoison/HTTPoison.Response.html#content","ref":"basic_concepts.html#requests-and-responses","title":"Basic Concepts - Requests and Responses","type":"extras"},{"doc":"ParsedItem is a structure which is filled by the parse_item/1 callback of the Spider. The structure is defined in the following way: @type item() :: %{} @type t :: %__MODULE__{ items: [item()], requests: [Crawly.Request.t()] } The parsed item is being processed by Crawly.Worker process, which sends all requests to the Crawly.RequestsStorage process, responsible for pre-processing requests and storing them for the future execution, all items are being sent to Crawly.DataStorage process, which is responsible for pre-processing items and storing them on disk.For now only one Storage backend is supported (writing on disc). But in future Crawly will also support work with amazon S3, sql and others.","ref":"basic_concepts.html#parsed-item","title":"Basic Concepts - Parsed Item","type":"extras"},{"doc":"Crawly is using a concept of pipelines when it comes to processing of the elements sent to the system. This is applied to both request and scraped item manipulation. Conceptually, requests go through a series of manipulations, before the response is fetched. The response then goes through another different series of manipulations.Importantly, the way that requests and responses are manipulated are abstracted into the Crawly.Pipeline behaviour. This allows for a modular system for declaring changes. It is also to be noted that Each Crawly.Pipeline module, when declared, are applied sequentially through the Crawly.Utils.pipe/3 function.Writing Tests for Custom PipelinesModules that implement the Crawly.Pipeline behaviour can make use of the Crawly.Utils.pipe/3 function to test for expected behaviour. Refer to the function documentation for more information and examples.","ref":"basic_concepts.html#the-crawly-pipeline-behaviour","title":"Basic Concepts - The Crawly.Pipeline Behaviour.","type":"extras"},{"doc":"These are configured under the middlewares option. See configuration for more details.Middleware: A pipeline module that modifies a request. It implements the Crawly.Pipeline behaviour.Middlewares are able to make changes to the underlying request, a Crawly.Request struct. The request, along with any options specified, is then passed to the fetcher (currently HTTPoison). The available configuration options should correspond to the underlying options of the fetcher in use.Note that all request configuration options for HTTPoison, such as proxy, ssl, etc can be configured through Crawly.Request.options.Built-in middlewares:Crawly.Middlewares.DomainFilter - this middleware will disable scheduling for all requests leading outside of the crawled site.Crawly.Middlewares.RobotsTxt - this middleware ensures that Crawly respects the robots.txt defined by the target website.Crawly.Middlewares.UniqueRequest - this middleware ensures that crawly would not schedule the same URL(request) multiple times.Crawly.Middlewares.UserAgent - this middleware is used to set a User Agent HTTP header. Allows to rotate UserAgents, if the last one is defined as a list.Crawly.Middlewares.RequestOptions - allows to set additional request options, for example timeout, of proxy string (at this moment the options should match options of the individual fetcher (e.g. HTTPoison))Crawly.Middlewares.AutoCookiesManager - allows to turn on the automatic cookies management. Useful for cases when you need to login or enter form data used by a website. Example: {Crawly.Middlewares.RequestOptions, [timeout: 30_000, recv_timeout: 15000]}, Crawly.Middlewares.AutoCookiesManagerResponse ParsersItem Pipelines: a pipeline module that parses a fetcher's request. If declared, a spider's c:Crawly.Spider.parse_item\\1 callback is ignored. It is unused by default. It implements the Crawly.Pipeline behaviour.Parsers allow for logic reuse when spiders parse a fetcher's response.Item PipelinesItem Pipelines: a pipeline module that modifies and pre-processes a scraped item. It implements the Crawly.Pipeline behaviour.Built-in item pipelines: Crawly.Pipelines.Validate - validates that a given item has all the required fields. All items which don't have all required fields are dropped. Crawly.Pipelines.DuplicatesFilter - filters out items which are already stored the system. Crawly.Pipelines.JSONEncoder- converts items into JSON format. Crawly.Pipelines.CSVEncoder- converts items into CSV format. Crawly.Pipelines.WriteToFile- Writes information to a given file.The list of item pipelines used with a given project is defined in the project settings.","ref":"basic_concepts.html#request-middlewares","title":"Basic Concepts - Request Middlewares","type":"extras"},{"doc":"Both item pipelines and request middlewares follows the Crawly.Pipeline behaviour. As such, when creating your custom pipeline, it will need to implement the required callback c:Crawly.Pipeline.run\\3.The c:Crawly.Pipeline.run\\3 callback receives the processed item, item from the previous pipeline module as the first argument. The second argument, state, is a map containing information such as spider which the item originated from (under the :spider_name key), and may optionally store pipeline information. Finally, opts is a keyword list containing any tuple-based options.Passing Configuration Options To Your PipelineTuple-based option declaration is supported, similar to how a GenServer is declared in a supervision tree. This allows for pipeline reusability for different use cases.For example, you can pass options in this way through your pipeline declaration:pipelines: [ {MyCustomPipeline, my_option: &quot;value&quot;} ]In your pipeline, you will then receive the options passed through the opts argument.defmodule MyCustomPipeline do @impl Crawly.Pipeline def run(item, state, opts) do IO.inspect(opts) # shows keyword list of [ my_option: &quot;value&quot; ] # Do something end endBest PracticesThe use of global configs is discouraged, hence one pass options through a tuple-based pipeline declaration where possible.When storing information in the state map, ensure that the state is namespaced with the pipeline name, so as to avoid key clashing. For example, to store state from MyEctoPipeline, store the state on the key :my_ecto_pipeline_my_state.Custom Request MiddlewaresRequest Middleware Example - Add a ProxyFollowing the documentation for proxy options of a request in HTTPoison, we can do the following:defmodule MyApp.MyProxyMiddleware do @impl Crawly.Pipeline def run(request, state, opts \\\\ []) do # Set default proxy and proxy_auth to nil opts = Enum.into(opts, %{proxy: nil, proxy_auth: nil}) case opts.proxy do nil -&gt; # do nothing {request, state} value -&gt; old_options = request.options new_options = [proxy: opts.proxy, proxy_auth: opts.proxy_auth] new_request = Map.put(request, :options, old_optoins ++ new_options) {new_request, state} end end endCustom Item PipelinesItem pipelines receives the parsed item (from the Spider) and performs post-processing on the item.Storing Parsed ItemsYou can use custom item pipelines to save the item to custom storages.Example - Ecto Storage PipelineIn this example, we insert the scraped item into a table with Ecto. This example does not directly call MyRepo.insert, but delegates it to an application context function.defmodule MyApp.MyEctoPipeline do @impl Crawly.Pipeline def run(item, state, _opts \\\\ []) do case MyApp.insert_with_ecto(item) do {:ok, _} -&gt; # insert successful, carry on with pipeline {item, state} {:error, _} -&gt; # insert not successful, drop from pipeline {false, state} end end endMultiple Different Types of Parsed ItemsIf you need to selectively post-process different types of scraped items, you can utilize pattern-matching at the item pipeline level.There are two general methods of doing so:Struct-based pattern matchingdefmodule MyApp.MyCustomPipeline do @impl Crawly.Pipeline def run(%MyItem{} = item, state, _opts \\\\ []) do # do something end # do nothing if it does not match def run(item, state, _opts), do: {item, state} endKey-based pattern matchingdefmodule MyApp.MyCustomPipeline do @impl Crawly.Pipeline def run(%{my_item: my_item} = item, state, _opts \\\\ []) do # do something end # do nothing if it does not match def run(item, state, _opts), do: {item, state} endUse struct-based pattern matching when:you want to utilize existing Ecto schemasyou have pre-defined structs that you want to conform toUse key-based pattern matching when:you want to process two or more related and inter-dependent items togetheryou want to bulk process multiple items for efficiency reasons. For example, processing the weather data for 365 days in one pass.CaveatsWhen using the nested-key pattern matching method, the spider's Crawly.Spider.parse_item/1 callback will need to return items with a single key (or a map with multiple keys, if doing related processing).When using struct-based pattern matching with existing Ecto structs, you will need to do an intermediate conversion of the struct into a map before performing the insertion into the Ecto Repo. This is due to the underlying Ecto schema metadata still being attached to the struct before insertion.Example - Multi-Item Pipelines With Pattern MatchingIn this example, your spider scrapes a &quot;blog post&quot; and a &quot;weather data&quot; from a website. We will use the key-based pattern matching approach to selectively post-process a blog post parsed item.# in MyApp.CustomSpider.ex def parse_item(response): # parse my item %{parsed_items: [ %{blog_post: blog_post} , %{weather: [ january_weather, february_weather ]} ]}Then, in the custom pipeline, we will pattern match on the :blog_post key, to ensure that we only process blog posts with this pipeline (and not weather data). We then update the :blog_post key of the received item.defmodule MyApp.BlogPostPipeline do @impl Crawly.Pipeline def run(%{blog_post: old_blog_post} = item, state, _opts \\\\ []) do # process the blog post updated_item = Map.put(item, :blog_post, %{my: &quot;data&quot;}) {updated_item, state} end # do nothing if it does not match def run(item, state, _opts), do: {item, state} end","ref":"basic_concepts.html#creating-a-custom-pipeline-module","title":"Basic Concepts - Creating a Custom Pipeline Module","type":"extras"},{"doc":"Browser rendering is one of the most complex problems of the scraping. The Internet moves towards more dynamic content, where not only parts of the pages are loaded asynchronously, but entire applications might be rendered by the JavaScript and AJAX.In most of the cases it's still possible to extract the data from dynamically rendered pages. (E.g. by sending additional POST requests from loaded pages), however this approach seems to have visible drawbacks. From our point of view it makes the spider code quite complicated and fragile.Of course it's good when you can just get pages already rendered for you. And we're solving this problem with a help of pluggable HTTP fetchers.Crawly's codebase contains a special Splash fetcher, which allows to do the browser rendering before the page content is being parsed by a spider. Also it's possible to build own fetchers.Using splash fetcher for browser renderingSplash is a lightweight opensourse browser implementation built with QT and python. See: https://splash.readthedocs.io/en/stable/api.htmlYou can try using Splash with Crawly in the following way:Start splash locally (e.g. using a docker image): docker run -it -p 8050:8050 scrapinghub/splash --max-timeout 300Configure Crawly to use Splash: fetcher: {Crawly.Fetchers.Splash, [base_url: &quot;http://localhost:8050/render.html&quot;]}Now all your pages will be automatically rendered by Splash.","ref":"basic_concepts.html#browser-rendering","title":"Basic Concepts - Browser rendering","type":"extras"},{"doc":"ConfigurationA basic example:config :crawly, pipelines: [ # my pipelines ], middlewares: [ # my middlewares ]","ref":"configuration.html","title":"Configuration","type":"extras"},{"doc":"middlewares :: [module()]Defines a list of middlewares responsible for pre-processing requests. If any of the requests from the Crawly.Spider is not passing the middleware configuration on the middlewares key, it's dropped.Refer to Crawly.Pipeline for more information on the structure of a middleware.# Example middlewares config :crawly, middlewares: [ Crawly.Middlewares.DomainFilter, Crawly.Middlewares.UniqueRequest, Crawly.Middlewares.RobotsTxt, # With options {Crawly.Middlewares.UserAgent, user_agents: [&quot;My Bot&quot;] }, {Crawly.Middlewares.RequestOptions, [timeout: 30_000, recv_timeout: 15000]} ]parsers :: [module()]default: nilBy default, parsers are unused, and a Crawly.Spider's parse_item/1 will be called to parse a fetcher's response. However, it is possible utilize Crawly's built-in parsers or your own custom logic to parse responses from a fetcher.IMPORTANT: If set at the global, ALL spiders will not have their parse_item/1 callback used. It is advised to declare these at the non-global level using spider-level settings overrides.Each parser may have additional peer dependencies if used. Refer to the documentation for each parser to know the specific requirements for each.Refer to Crawly.Pipeline for more information on the structure of a parser.config :crawly, parsers: [ {Crawly.Parsers.ExtractRequests, selector: &quot;button&quot;}, ]pipelines :: [module()]default: []Defines a list of pipelines responsible for pre processing all the scraped items. All items not passing any of the pipelines are dropped. If unset, all items are stored without any modifications.Refer to Crawly.Pipeline for more information on the structure of a pipeline.config :crawly, pipelines: [ {Crawly.Pipelines.Validate, fields: [:id, :date]}, {Crawly.Pipelines.DuplicatesFilter, item_id: :id}, Crawly.Pipelines.JSONEncoder, {Crawly.Pipelines.WriteToFile, extension: &quot;jl&quot;, folder: &quot;/tmp&quot;, include_timestamp: true} ]closespider_itemcount :: pos_integer() | :disableddefault: :disabledAn integer which specifies a number of items. If the spider scrapes more than that amount and those items are passed by the item pipeline, the spider will be closed. If set to :disabled the spider will not be stopped.closespider_timeout :: pos_integer()default: nil (disabled by default)Defines a minimal amount of items which needs to be scraped by the spider within the given timeframe (1m). If the limit is not reached by the spider - it will be stopped.concurrent_requests_per_domain :: pos_integer()default: 4Indicates the number of Crawly workers that will be used to make simultaneous requests on a per-spider basis.Each Crawly worker is rate-limited to a maximum of 4 requests per minute. Hence, by default, the number of requests possible would be 4 x 4 = 16 req/min.In order to increase the number of requests made per minute, set this option to a higher value. The default value is intentionally set at 4 for ethical crawling reasons.NOTE: A worker's speed if often limited by the speed of the actual HTTP client and network bandwidth, and may be less than 4 requests per minute.retry :: Keyword listAllows to configure the retry logic. Accepts the following configuration options:retry_codes: Allows to specify a list of HTTP codes which are treated as failed responses. (Default: [])max_retries: Allows to specify the number of attempts before the request is abandoned. (Default: 0)ignored_middlewares: Allows to modify the list of processors for a given requests when retry happens. (Will be required to avoid clashes with Unique.Request middleware).Example: retry: [ retry_codes: [400], max_retries: 3, ignored_middlewares: [Crawly.Middlewares.UniqueRequest] ] fetcher :: atom()default: Crawly.Fetchers.HTTPoisonFetcherAllows to specify a custom HTTP client which will be performing request to the crawler target.log_dir :: String.t()default: /tmpSet spider logs directory. All spiders have their own dedicated log file stored under the log_dir folder. This option is ignored if log_to_file is not set to true.log_to_file :: String.t()default: falseEnables or disables file logging.port :: pos_integer()default: 4001Allows to specify a custom port to start the application. That is important when running more than one application in a single machine, in which case shall not use the same port as the others.on_spider_closed_callback :: function()default: :ignoredA function that takes three arguments: spider_name, crawl_id and reason of spider stop. Allows to define a callback function which will be executed when spider finishes it's work.","ref":"configuration.html#options","title":"Configuration - Options","type":"extras"},{"doc":"It's possible to override most of the setting on a spider level. In order to do that, it is required to define the override_settings/0 callback in your spider.For example:def override_settings() do [ concurrent_requests_per_domain: 5, closespider_timeout: 6 ] endThe full list of overridable settings:closespider_itemcount,closespider_timeout,concurrent_requests_per_domain,fetcher,retry,pasers,middlewares (has known bugs)pipelines","ref":"configuration.html#overriding-global-settings-on-spider-level","title":"Configuration - Overriding global settings on spider level","type":"extras"},{"doc":"HTTP APICrawly supports a basic HTTP API, which allows to control the Engine behaviour.","ref":"http_api.html","title":"HTTP API","type":"extras"},{"doc":"The following command will start a given Crawly spider:curl -v localhost:4001/spiders/&lt;spider_name&gt;/schedule","ref":"http_api.html#starting-a-spider","title":"HTTP API - Starting a spider","type":"extras"},{"doc":"The following command will stop a given Crawly spider:curl -v localhost:4001/spiders/&lt;spider_name&gt;/stop","ref":"http_api.html#stopping-a-spider","title":"HTTP API - Stopping a spider","type":"extras"},{"doc":"curl -v localhost:4001/spiders","ref":"http_api.html#getting-currently-running-spiders","title":"HTTP API - Getting currently running spiders","type":"extras"},{"doc":"curl -v localhost:4001/spiders/&lt;spider_name&gt;/scheduled-requests curl -v localhost:4001/spiders/&lt;spider_name&gt;/scraped-items","ref":"http_api.html#getting-spider-stats","title":"HTTP API - Getting spider stats","type":"extras"},{"doc":"Ethical CrawlingIt is important to be polite when performing web crawling. Avoid harming scraped websites. Scraping politely:A polite crawler respects robots.txt.A polite crawler never degrades a website’s performance.A polite crawler identifies its creator with contact information.A polite crawler is not a pain in the buttocks of system administrators.","ref":"ethical_aspects.html","title":"Ethical Crawling","type":"extras"},{"doc":"Experimental UIIf you are interested in our attempts to make crawling more predictable, have a glance on: https://github.com/oltarasenko/crawly_ui","ref":"experimental_ui.html","title":"Experimental UI","type":"extras"},{"doc":"You can find setup examples hereOn the highest level it's required to:Add SendToUI pipeline to the list of your item pipelines (before encoder pipelines) {Crawly.Pipelines.Experimental.SendToUI, ui_node: :'ui@127.0.0.1'}Organize erlang cluster so Crawly nodes can find CrawlyUI node in the example above I was using erlang-node-discovery application for this task, however any other alternative would also work. For setting up erlang-node-discovery add the following code dependency to deps section of mix.exs {:erlang_node_discovery, git: &quot;https://github.com/oltarasenko/erlang-node-discovery&quot;}add the following lines to the config.exs: config :erlang_node_discovery, hosts: [&quot;127.0.0.1&quot;, &quot;crawlyui.com&quot;], node_ports: [ {:ui, 0} ]","ref":"experimental_ui.html#setting-it-up","title":"Experimental UI - Setting it up","type":"extras"},{"doc":"You can send logs to CrawlyUI as well. In order to do that you have to add the following (changing your node name of course) to your config:# tell logger to load a LoggerFileBackend processes config :logger, backends: [ :console, {Crawly.Loggers.SendToUiBackend, :send_log_to_ui} ], level: :debug config :logger, :send_log_to_ui, destination: {:&quot;ui@127.0.0.1&quot;, CrawlyUI, :store_log}","ref":"experimental_ui.html#setting-up-logger","title":"Experimental UI - Setting up logger","type":"extras"},{"doc":"Crawly","ref":"readme.html","title":"Introduction","type":"extras"},{"doc":"Crawly is an application framework for crawling web sites and extracting structured data which can be used for a wide range of useful applications, like data mining, information processing or historical archival.","ref":"readme.html#overview","title":"Introduction - Overview","type":"extras"},{"doc":"Elixir &quot;~&gt; 1.10&quot;Works on Linux, Windows, OS X and BSD","ref":"readme.html#requirements","title":"Introduction - Requirements","type":"extras"},{"doc":"Add Crawly as a dependencies:# mix.exs defp deps do [ {:crawly, &quot;~&gt; 0.13.0&quot;}, {:floki, &quot;~&gt; 0.26.0&quot;} ] endFetch dependencies: $ mix deps.getCreate a spider# lib/crawly_example/esl_spider.ex defmodule EslSpider do use Crawly.Spider alias Crawly.Utils @impl Crawly.Spider def base_url(), do: &quot;https://www.erlang-solutions.com&quot; @impl Crawly.Spider def init(), do: [start_urls: [&quot;https://www.erlang-solutions.com/blog/&quot;]] @impl Crawly.Spider def parse_item(response) do {:ok, document} = Floki.parse_document(response.body) hrefs = document |&gt; Floki.find(&quot;a.btn-link&quot;) |&gt; Floki.attribute(&quot;href&quot;) requests = Utils.build_absolute_urls(hrefs, base_url()) |&gt; Utils.requests_from_urls() title = document |&gt; Floki.find(&quot;h1.page-title-sm&quot;) |&gt; Floki.text() %{ :requests =&gt; requests, :items =&gt; [%{title: title, url: response.request_url}] } end endConfigure CrawlyBy default, Crawly does not require any configuration. But obviously you will need a configuration for fine tuning the crawls:# in config.exs config :crawly, closespider_timeout: 10, concurrent_requests_per_domain: 8, middlewares: [ Crawly.Middlewares.DomainFilter, Crawly.Middlewares.UniqueRequest, {Crawly.Middlewares.UserAgent, user_agents: [&quot;Crawly Bot&quot;]} ], pipelines: [ {Crawly.Pipelines.Validate, fields: [:url, :title]}, {Crawly.Pipelines.DuplicatesFilter, item_id: :title}, Crawly.Pipelines.JSONEncoder, {Crawly.Pipelines.WriteToFile, extension: &quot;jl&quot;, folder: &quot;/tmp&quot;} ]Start the Crawl:$ iex -S mixiex(1)&gt; Crawly.Engine.start_spider(EslSpider)Results can be seen with: $ cat /tmp/EslSpider.jl","ref":"readme.html#quickstart","title":"Introduction - Quickstart","type":"extras"},{"doc":"I have decided to create a public telegram channel, so it's now possible to be connected, and it's possible to ask questions and get answers faster!Please join me on: https://t.me/crawlyelixir","ref":"readme.html#need-more-help","title":"Introduction - Need more help?","type":"extras"},{"doc":"Crawly can be configured in the way that all fetched pages will be browser rendered, which can be very useful if you need to extract data from pages which has lots of asynchronous elements (for example parts loaded by AJAX).You can read more here:Browser Rendering","ref":"readme.html#browser-rendering","title":"Introduction - Browser rendering","type":"extras"},{"doc":"The CrawlyUI project is an add-on that aims to provide an interface for managing and rapidly developing spiders.Checkout the code from GitHub or try it online CrawlyUIDemoSee more at Experimental UI","ref":"readme.html#experimental-ui","title":"Introduction - Experimental UI","type":"extras"},{"doc":"API ReferenceQuickstartTutorial","ref":"readme.html#documentation","title":"Introduction - Documentation","type":"extras"},{"doc":"[x] Pluggable HTTP client[x] Retries support[x] Cookies support[x] XPath support - can be actually done with meeseeks[ ] Project generators (spiders)[ ] UI for jobs management","ref":"readme.html#roadmap","title":"Introduction - Roadmap","type":"extras"},{"doc":"Blog post on Erlang Solutions website: https://www.erlang-solutions.com/blog/web-scraping-with-elixir.htmlBlog post about using Crawly inside a machine learning project with Tensorflow (Tensorflex): https://www.erlang-solutions.com/blog/how-to-build-a-machine-learning-project-in-elixir.htmlWeb scraping with Crawly and Elixir. Browser rendering: https://medium.com/@oltarasenko/web-scraping-with-elixir-and-crawly-browser-rendering-afcaacf954e8Web scraping with Elixir and Crawly. Extracting data behind authentication: https://oltarasenko.medium.com/web-scraping-with-elixir-and-crawly-extracting-data-behind-authentication-a52584e9cf13What is web scraping, and why you might want to use it?Using Elixir and Crawly for price monitoring","ref":"readme.html#articles","title":"Introduction - Articles","type":"extras"},{"doc":"Blog crawler: https://github.com/oltarasenko/crawly-spider-exampleE-commerce websites: https://github.com/oltarasenko/products-advisorCar shops: https://github.com/oltarasenko/crawly-carsJavaScript based website (Splash example): https://github.com/oltarasenko/autosites","ref":"readme.html#example-projects","title":"Introduction - Example projects","type":"extras"},{"doc":"We would gladly accept your contributions!","ref":"readme.html#contributors","title":"Introduction - Contributors","type":"extras"},{"doc":"Please find documentation on the HexDocs","ref":"readme.html#documentation","title":"Introduction - Documentation","type":"extras"},{"doc":"Using Crawly on production? Please let us know about your case!","ref":"readme.html#production-usages","title":"Introduction - Production usages","type":"extras"}]